"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var DEFAULT_DEBOUNCE = 250;

var _default = function _default(original) {
  var millis = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_DEBOUNCE;
  var pid;
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return new Promise(function (resolve) {
      var invoke = function invoke() {
        return Promise.resolve(original.apply(void 0, args)).then(function (res) {
          pid = null;
          resolve(res);
        });
      };

      clearTimeout(pid);
      pid = setTimeout(invoke, pid === undefined ? 0 : millis);
    });
  };
};

exports["default"] = _default;