"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = require("react");

var _memoize = _interopRequireDefault(require("./memoize"));

var _debounce = _interopRequireDefault(require("./debounce"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var config = [function (_ref) {
  var _ref$state = _ref.state,
      state = _ref$state === void 0 ? {} : _ref$state;
  return {
    loading: true,
    data: state.data
  };
}, function (_ref2) {
  var payload = _ref2.payload;
  return {
    loading: false,
    data: payload
  };
}, function (_ref3) {
  var payload = _ref3.payload;
  return {
    loading: false,
    error: payload
  };
}];

var asyncReducer = function asyncReducer(state, _ref4) {
  var type = _ref4.type,
      payload = _ref4.payload;
  return config[type]({
    state: state,
    payload: payload
  });
};

var prepareFn = function prepareFn(original, options) {
  var fn = original;

  if (options && options.debounce) {
    fn = (0, _debounce["default"])(fn, options.debounce);
  }

  if (options && options.memoize) {
    fn = (0, _memoize["default"])(fn);
  }

  return fn;
};

var _default = function _default(fn) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var _useReducer = (0, _react.useReducer)(asyncReducer, {
    loading: false
  }),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      state = _useReducer2[0],
      _dispatch = _useReducer2[1];

  var original = (0, _react.useRef)(prepareFn(fn, options));

  var _useRef = (0, _react.useRef)(function () {
    _dispatch({
      type: 0
    });

    Promise.resolve(original.current.apply(original, arguments)).then(function (payload) {
      return _dispatch({
        type: 1,
        payload: payload
      });
    })["catch"](function (payload) {
      return _dispatch({
        type: 2,
        payload: payload
      });
    });
  }),
      dispatch = _useRef.current;

  return _objectSpread({
    dispatch: dispatch
  }, state);
};

exports["default"] = _default;