"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _default = function _default(original) {
  if (typeof original !== 'function') {
    throw new Error('memoize requires a function as a first parameter');
  }

  var cache = {};
  return function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var n = args[0];

    if (n in cache) {
      return Promise.resolve(cache[n]);
    }

    return new Promise(function (resolve, reject) {
      original.apply(void 0, args).then(function (res) {
        cache[n] = res;
        resolve(res);
      })["catch"](reject);
    });
  };
};

exports["default"] = _default;